%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PVC:SYS-DM.SL
% Title:        Lisp item constructors & selectors for VAX Syslisp
% Author:       Eric Benson, University of Utah
% Created:	10-Jul-81
% Modified:     24 Feb 1984 1745-PST
% Status:       Experimental (Do Not Distribute)
% Mode:         Lisp
% Package:      SYSLISP
%
% Copyright (c) 1990 Konrad-Zuse-Zentrum
% Copyright (c) 1983, 1984 Hewlett-Packard
% Copyright (c) 1981 University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Retrieve the address stored in the function cell


(dm SymFnc (U)
  `(getmem (wplus2 SymFnc (wtimes2 addressingunitsperfunctioncell ,(cadr U)) )))

% Can't really do PutSymFnc

(dm PutSymFnc (U) 
    '(StdError 'PutSymFnc does not exist on the VAX))

 % access to SYMget vector

(dm Symget (U)
        `(wgetv Symget ,(cadr U)))

% Macros for building stack pointers, no-ops on the VAX

(ds MakeStackPointerFromAddress (x) 
  x
  )

(ds MakeAddressFromStackPointer (x) 
  x
  )

(RemProp 'AdjustStackPointer 'OpenFn)

(ds AdjustStackPointer (stack-pointer offset) 
  (wdifference stack-pointer offset)
  )

(ds righthalf (x)
  (field x 0 16)
  )


