%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:CONT-ERROR.SL 
% Title:        Nice macro to set up arguments for ContinuableError 
% Author:       Eric Benson 
% Created:      23 August 1981 
% Modified:     22-Mar-84 10:58:07 (Brian Beach) 
% Status:       Experimental 
% Mode:         Lisp 
% Package:      Kernel 
% Compiletime:  
% Runtime:      
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Dec-83 14:26:21 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(dm conterror (u)
  %. Set up for ContinuableError
  (prog (errornumber message reevalform)
    (setq u (cdr u))
    (setq errornumber (car u))
    (setq u (cdr u))
    (cond ((null (cddr u)) % if it's just a string, don't
	   (progn (setq message (car u))
		  % generate call to BldMsg
		  (setq u (cdr u))))
	  (t (while (cdr u)
	       (setq message (aconc message (car u)))
	       (setq u (cdr u)))
	     (setq message (cons 'bldmsg message))))
    (setq reevalform (car u))
    (setq reevalform (if (not (pairp reevalform))
		       (list 'mkquote reevalform)
		       (cons 'list
			     (cons (mkquote (car reevalform))
				   (foreach x in (cdr reevalform) collect
					    (list 'mkquote x))))))
    (return (list 'continuableerror errornumber message reevalform))))

