%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:DUMPLISP.SL
% SCCS:		@(#) dumplisp.sl 1.2@(#) 10/17/84 12:25:18
% Description:  Dump running lisp to an a.out format file, based on VAX version
% Author:       RAM, HP/FSD
% Created:      27-Feb-84
% Modified:     14-Jan-85 09:10:20 (Vicki O'Day)
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 27-Sep-89 (Winfried Neun)
%  savesystem will reset gcknt* and gctime* to 0
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (remprop 'putbittable 'opencode))

(compiletime (load fasl-decls))

(compiletime (on fast-integers))

(de putbittable (baseaddress bitoffset value2)
  (prog (m b c)
        (setq b
              (iland (byte baseaddress (setq m (ilsh bitoffset -2)))
                     (ilsh (idifference -1 (itimes2 3 256))
                      (idifference -2
                       (setq c (itimes2 (field bitoffset 30 2) 2))))))
        (putbyte baseaddress m (if (eq value2 0)
                   b
                   (ilor b (ilsh value2 (idifference 6 c)))))))


(fluid '(gcknt* gctime* ))

(global '(nextbps heaplast heapupperbound oldheapupperbound stacklowerbound))

(de dumplisp (filename)
  (prog (table x y)
         
               % build table for parameters
        (setq bittable-chain nil)
        (setq  table (make-words 5 0))
        (setindx table 0 MAXSYMBOLS)
 
        (reclaim)                               % best time now
        (when (wgreaterp heaplast oldheapupperbound)
              (reclaim))  % move to lower heap

        (setq gcknt* 0 gctime* 0)
        (unexec (strbase (strinf filename)) (wrdbase (wrdinf table)))
   ))


